Bug 1412881 - RFE: overlayfs to replace thinpool storage mechanism for docker
Summary: RFE: overlayfs to replace thinpool storage mechanism for docker
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: docker
Version: 7.3
Hardware: x86_64
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Daniel Walsh
QA Contact: atomic-bugs@redhat.com
URL:
Whiteboard:
Depends On:
Blocks: 1388183 1420851
TreeView+ depends on / blocked
 
Reported: 2017-01-13 03:30 UTC by Ian Wells
Modified: 2019-03-06 01:25 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-02 00:11:21 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2017:2344 normal SHIPPED_LIVE docker bug fix and enhancement update 2017-08-08 22:51:38 UTC

Description Ian Wells 2017-01-13 03:30:52 UTC
Description of problem:

Docker thinpools are not recommended upstream by Docker, and operationally it is not possible to get key information about thinpool status - for instance, the usage within the thinpool for a specific container.  Docker thinpools are easy to fill (and tracking usage is hard) and recovering from a full thinpool is incredibly difficult.

overlayfs seems to be the best supported storage backend available from the upstream community, but I can find no documentation that suggests that this is supported for RHEL (and I've heard you don't include overlayfs2 in your kernel).  Please support the overlayfs storage driver as a storage backend for Docker.


To see this go horribly wrong:

docker start <an-image> -it dd if=/dev/random of=/bigfile

... and wait.  In the meantime, try and work out how much of the thinpool the container in question is taking up.

Comment 2 Daniel Walsh 2017-01-13 12:54:46 UTC
We are working on overlay.  overlay2 is fully supported, this has nothing to do with the kernel.  Overlay and SELinux do not currently work together, although this has been fixed in upstream kernels.   And we will definitely have this fixed in the RHEL kernel, by RHEL7.4 if not sooner.

You can run with overlay and ovleray2 in docker-1.12 release on RHEL, but you have to turn off SELinux, in docker daemon, until the kernel is fixed.  (Obviously something I am not crazy about advising)

Overlay is also not Posix Compliant, so we are concerned about certain workloads not working correctly.  There are several fixes/issues in the kernel to fix a few of these.

We have a proposal to change the default in Fedora 26 to get more play time on this.

Comment 5 Ian Wells 2017-02-10 19:50:53 UTC
Sounds helpful.  To be fair, I phrased this wrong - I'm less worried that overlay specifically is the solution you choose and more concerned that the thinpool model is hard to work with.  Whatever solution you have that gets me a manageable docker store with upstream support will do nicely.

Comment 6 Daniel Walsh 2017-06-30 15:22:20 UTC
This will be fixed in RHEL7.4.

Comment 8 Luwen Su 2017-07-25 03:46:44 UTC
As overlay/overlay2 is supported with selinux in docker-1.12.6-48.git0fdc778.el7.x86_64, move to verified.

Comment 10 errata-xmlrpc 2017-08-02 00:11:21 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2017:2344


Note You need to log in before you can comment on or make changes to this bug.